{
  "nbformat": 4,
  "nbformat_minor": 0,
  "metadata": {
    "colab": {
      "name": "easyoccccccccccrfinallllll.ipynb",
      "provenance": [],
      "collapsed_sections": []
    },
    "kernelspec": {
      "name": "python3",
      "display_name": "Python 3"
    },
    "language_info": {
      "name": "python"
    }
  },
  "cells": [
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "t83s3GrKQz0J",
        "outputId": "040d363c-cadf-474c-e946-553eaa810051"
      },
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Requirement already satisfied: easyocr in /usr/local/lib/python3.7/dist-packages (1.4.2)\n",
            "Requirement already satisfied: scikit-image in /usr/local/lib/python3.7/dist-packages (from easyocr) (0.18.3)\n",
            "Requirement already satisfied: Pillow in /usr/local/lib/python3.7/dist-packages (from easyocr) (9.0.1)\n",
            "Requirement already satisfied: opencv-python-headless<=4.5.4.60 in /usr/local/lib/python3.7/dist-packages (from easyocr) (4.5.4.60)\n",
            "Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from easyocr) (1.21.5)\n",
            "Requirement already satisfied: python-bidi in /usr/local/lib/python3.7/dist-packages (from easyocr) (0.4.2)\n",
            "Requirement already satisfied: scipy in /usr/local/lib/python3.7/dist-packages (from easyocr) (1.4.1)\n",
            "Requirement already satisfied: torch in /usr/local/lib/python3.7/dist-packages (from easyocr) (1.10.0+cu111)\n",
            "Requirement already satisfied: torchvision>=0.5 in /usr/local/lib/python3.7/dist-packages (from easyocr) (0.11.1+cu111)\n",
            "Requirement already satisfied: PyYAML in /usr/local/lib/python3.7/dist-packages (from easyocr) (3.13)\n",
            "Requirement already satisfied: typing-extensions in /usr/local/lib/python3.7/dist-packages (from torch->easyocr) (4.1.1)\n",
            "Requirement already satisfied: six in /usr/local/lib/python3.7/dist-packages (from python-bidi->easyocr) (1.15.0)\n",
            "Requirement already satisfied: matplotlib!=3.0.0,>=2.0.0 in /usr/local/lib/python3.7/dist-packages (from scikit-image->easyocr) (3.2.2)\n",
            "Requirement already satisfied: networkx>=2.0 in /usr/local/lib/python3.7/dist-packages (from scikit-image->easyocr) (2.6.3)\n",
            "Requirement already satisfied: tifffile>=2019.7.26 in /usr/local/lib/python3.7/dist-packages (from scikit-image->easyocr) (2021.11.2)\n",
            "Requirement already satisfied: PyWavelets>=1.1.1 in /usr/local/lib/python3.7/dist-packages (from scikit-image->easyocr) (1.3.0)\n",
            "Requirement already satisfied: imageio>=2.3.0 in /usr/local/lib/python3.7/dist-packages (from scikit-image->easyocr) (2.4.1)\n",
            "Requirement already satisfied: pyparsing!=2.0.4,!=2.1.2,!=2.1.6,>=2.0.1 in /usr/local/lib/python3.7/dist-packages (from matplotlib!=3.0.0,>=2.0.0->scikit-image->easyocr) (3.0.8)\n",
            "Requirement already satisfied: kiwisolver>=1.0.1 in /usr/local/lib/python3.7/dist-packages (from matplotlib!=3.0.0,>=2.0.0->scikit-image->easyocr) (1.4.2)\n",
            "Requirement already satisfied: cycler>=0.10 in /usr/local/lib/python3.7/dist-packages (from matplotlib!=3.0.0,>=2.0.0->scikit-image->easyocr) (0.11.0)\n",
            "Requirement already satisfied: python-dateutil>=2.1 in /usr/local/lib/python3.7/dist-packages (from matplotlib!=3.0.0,>=2.0.0->scikit-image->easyocr) (2.8.2)\n",
            "Requirement already satisfied: pybind11 in /usr/local/lib/python3.7/dist-packages (2.9.2)\n",
            "Requirement already satisfied: fastwer in /usr/local/lib/python3.7/dist-packages (0.1.3)\n",
            "Requirement already satisfied: pybind11 in /usr/local/lib/python3.7/dist-packages (from fastwer) (2.9.2)\n"
          ]
        }
      ],
      "source": [
        "!pip install easyocr\n",
        "!pip install pybind11\n",
        "!pip install fastwer"
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "!pip install torch torchvision torchaudio"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "6Y1RCPXHSA1K",
        "outputId": "e524d770-630d-4ce8-e1bf-bc04292ee9a3"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Requirement already satisfied: torch in /usr/local/lib/python3.7/dist-packages (1.10.0+cu111)\n",
            "Requirement already satisfied: torchvision in /usr/local/lib/python3.7/dist-packages (0.11.1+cu111)\n",
            "Requirement already satisfied: torchaudio in /usr/local/lib/python3.7/dist-packages (0.10.0+cu111)\n",
            "Requirement already satisfied: typing-extensions in /usr/local/lib/python3.7/dist-packages (from torch) (4.1.1)\n",
            "Requirement already satisfied: numpy in /usr/local/lib/python3.7/dist-packages (from torchvision) (1.21.5)\n",
            "Requirement already satisfied: pillow!=8.3.0,>=5.3.0 in /usr/local/lib/python3.7/dist-packages (from torchvision) (9.0.1)\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "import easyocr\n",
        "import cv2\n",
        "from matplotlib import pyplot as plt\n",
        "import numpy as np\n",
        "import fastwer\n",
        "import os\n",
        "import pandas as pd\n",
        "from IPython.display import Image, display\n",
        "# Define reference text and output text\n",
        "ref = 'my name is kenneth'\n",
        "output = 'myy nime iz kenneth'\n",
        "\n",
        "# Obtain Sentence-Level Character Error Rate (CER)\n",
        "fastwer.score_sent(output, ref, char_level=True)\n"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "bXCXASBLSA4S",
        "outputId": "6271240e-b345-44c6-d405-5f6ddcdef037"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "16.6667"
            ]
          },
          "metadata": {},
          "execution_count": 95
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "# Define reference text and output text\n",
        "ref = 'my name is kenneth'\n",
        "output = 'myy nime iz kenneth'\n",
        "\n",
        "# Obtain Sentence-Level Character Error Rate (CER)\n",
        "fastwer.score_sent(output, ref, char_level=True)"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "hxR96HTiSA69",
        "outputId": "e2a5c5fe-a5ad-448b-a2f1-ef443e9166dd"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "16.6667"
            ]
          },
          "metadata": {},
          "execution_count": 96
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "fastwer.score_sent(output, ref)\n"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "Yxnv4CSWSA9V",
        "outputId": "8845fa4f-d215-4308-9ab1-1af1e5835328"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "75.0"
            ]
          },
          "metadata": {},
          "execution_count": 97
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "img_list = os.listdir('/content/drive/MyDrive/huu')\n",
        "img_list = sorted(img_list)\n",
        "img_list"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "8AQSDETySA_P",
        "outputId": "78fe9706-e71f-458f-ce82-8d3f0a27d466"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "['800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png',\n",
              " 'Arabic_Typesetting_Font.svg.png',\n",
              " 'arabic-words-and-phrases-vector-22578359.jpg',\n",
              " 'capr10.png',\n",
              " 'capr2.png',\n",
              " 'cdd.jpg',\n",
              " 'cddd.jpg',\n",
              " 'font_preview-ae8a8c44055469537eec30890fd91d074584.png',\n",
              " 'hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg',\n",
              " 'kashida-justification.png',\n",
              " 'pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg',\n",
              " 'r.jpg',\n",
              " 'sti.jpg',\n",
              " 'traditional-arabic-regular.png']"
            ]
          },
          "metadata": {},
          "execution_count": 98
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "for i, img in enumerate(img_list):\n",
        "  print(f'Display sample image {i+1} - {img}')\n",
        "  display(Image(filename=f'/content/drive/MyDrive/huu/{img}'))\n"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/",
          "height": 1000
        },
        "id": "Ntl5xJfIS0cF",
        "outputId": "543161d1-7885-4b83-b636-0cac3606f54e"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 1 - 800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 45176 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 2 - Arabic_Typesetting_Font.svg.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 38380 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 3 - arabic-words-and-phrases-vector-22578359.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 210328 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 4 - capr10.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 241724 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 5 - capr2.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 57712 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 6 - cdd.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 356508 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 7 - cddd.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 104200 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 8 - font_preview-ae8a8c44055469537eec30890fd91d074584.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 11232 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 9 - hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 23968 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 10 - kashida-justification.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 43860 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 11 - pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 22516 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 12 - r.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 52708 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 13 - sti.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 10944 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 14 - traditional-arabic-regular.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 10240 characters]\n"
          },
          "metadata": {}
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "df_output = pd.DataFrame(columns = ['img_filename', 'ocr_output'])\n",
        "reader =easyocr.Reader(['ar'], gpu=False)"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "FGy3Au4dS0dk",
        "outputId": "20e5bb5d-777a-4d66-9f28-f821c9a1b020"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stderr",
          "text": [
            "Using CPU. Note: This module is much faster with a GPU.\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "!pip install Pillow==9.0.1\n",
        "\n",
        "for img in img_list:\n",
        "  im = cv2.imread(f'/content/drive/MyDrive/huu/{img}')\n",
        "  img_rgb = cv2.cvtColor(im, cv2.COLOR_BGR2RGB)\n",
        "  extract = reader.readtext(img_rgb,detail=0,paragraph=\"True\")\n",
        "  print(extract)\n",
        "  print(img)\n",
        "  dictionary = {'img_filename':img, 'ocr_output':str(extract)}\n",
        "  df_output = df_output.append(dictionary, ignore_index=True)\n"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "Ws1uI7XKS0fj",
        "outputId": "bf41e6b3-a58c-4ab4-9642-9d2e960ac654"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Requirement already satisfied: Pillow==9.0.1 in /usr/local/lib/python3.7/dist-packages (9.0.1)\n",
            "['خ طلمحة النحيف خط لمحة العادي خط لمحة العريض']\n",
            "800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png\n",
            "[]\n",
            "Arabic_Typesetting_Font.svg.png\n",
            "['مايسان ماذا تريد ماذا حصل أديسون ماذا قللم ما هذا ماذا تعمل سلام ماذا تحتاج الكحول 22578359/\"0ء .*ء٥5٥ع  ٥م،ع']\n",
            "arabic-words-and-phrases-vector-22578359.jpg\n",
            "['يقول الله تبارك وتعال واضرب لهم مثلا اصحاب القدي اذ جاها المرسلون آذا ادسلنا البام اثفين فكذبوهما فعززنا بثالث فقالوا انا اليكم مرسلون اولا ما هي قصتهم يذكر لنا النثرن الكريم هم اصحاب القري ولا ما القري وهناك روايات كثير ولا طال من ورا الجرمعها انما بهمنا من ئذه القص نش العبر والعط منها فدبا قري ارسل الله اليها رسولين فكذبوهما اهل تلك القد فعززهما الله برسول ثالث وتقدموا ثلاثت م بدعواهم ودعوتهم من جديد فقالوا انا اليكم مرسلون وشنا اعترض اهل القري بالاعتراضات المكررفر تاريخ الرسل والرسالات قالوا ما انتم الا بشر مثلنا وما انزل الرحمن من شب اننم الا تكذبون وفي الممن المطمن ال الصدق العارف بحدود وظيفته اجابهم الرسمل قالوا ربنا يعلم انا اليكم لمرسلون وما علينا الا البلاغ المبين ايان الثه يعلم هذا ويكفي وان وظيف الرسل هي البلاغ وقد ادوه والناس بعد ذلك احرار فيما يتخذونه لانفسهم من تصرف وفيما يحملون تصرفهم من اوزار والامر بين الرسل وبين الناس موامر ذلك التبليغ الله تعال فمت تحقق ذلك فالمر كله بعد ذلك ل٧ه ولكن _ المكذبين كعادتهم لا يخذون الامور عل هدا المخد الواصخ ولا يطيقون وجود الدعا ال الهد فتخذهم العز بالاثم ويعمدون ال الاسلوب الفليظ في مقاوم الحج لان الباطل ضيق الصدر قالوا انا تطيرنا بكم لم تنتهوا لنرجمنكم وليمسنكم منا عذاب آليم وشكذا اسفر الباطل عن غشمه واطلق عل الهدا تهديده ولكن الواجب عل الرسل ان يسيروا في طريق دعوتهم لدا الواجب عليام فردوا عليهم قالوا طاركم معكم لان القول بالتشام خراف وواجب الرسل ان يبينوا لقومهم انها خراف وان حطحم ونصيبهم من ومن لا يتيهم من خارج انشسهم اذما معهم مرتبط بنواياهم واعمالهم متوقف عل كسب3م وعملهم وفب وسعهم ان يجعلوا حظهم ونصيبهم خيرا اوان يجعلوه شرا ان ذكرتم يعن اتعذبونا وترجمونا لاننا نذكركم افهذا جزاا التذكير بل انتم قوم مسرفون يعن تجاوزتم الحدود وتردون عل الدعو  الخير تردون بالرجم والتعذيب ولكن داما تجد الحير في قلوب بعض الرجال وتجد الفطر السيم الداعي المازر والمناصر لدين الحق فهذا رجل يسمع لدعو الحق فينطق بكلم الحق المبين قال تعالوجا من قص المدين رجل يسع قال يا 799 اتبعوا المرسلين اتبعوا من لا يسلكم اجرا وهم مهتدون ايان الذي يدعومثل هذه الدعو 9س9 يطلب اجرا انه لصادق والا فما الذي يحمله عل هذا العناان لم يكن يلب تكليفا من الله تعال ودعوتهم واضح فهم يدعون ال اله واحد ويدعون ال منهج سليم ثم عاد هذا الرجل الممن يتحدث اليهم عن نفسه وعن اسباب ابمانه ومالي لا اعبد الذي فطرني واليه ترجعون يتسال لم لا اعبد الذي فطرني وهواليه المرجع والمصير اخذ يبين لهم ان من يخالف هذا المنهج فنهايته معروف ثم يلق كلم النهاي اني منت بربكم فاسمعون هكذا الق كلم الايمان الواثق واشهدهم عليها ويوحي سياق النم ان قومه لم يمهلوه وقتلوه وتنتهي الدنيا ونراه العالم الخر وقد اكرمه الله بدخول الجن فيل ادخل  الجن قال يا ليت  قومب يعلمون بما غفرلي ربي وجعلني من المكرمين وذر الرجل الممن بعدان اراه الله منزلته في الجن يقول ويتمن يراه قومه وقد اتاه الله من الكرام والمففر ليعرفوا الحق معرف اليقين ويخبرنا الله تعال انه انتقم من قومه بعد قتلهم اياه غضبا منه تبارك وتعال عليهم لانهم كذبوا ردسمله وقتلوا وليه ويذكر الله تعال ما انزل عليهم من عذاب قال تعالان كانت الا صيح واحد فذا هم خامدون قال علما التفسبر بعت الله اليهم جبريل عليه السلام فخذ بعضادتي الباب الذي ببلدهم ثم صاح ب4م واحد فذاهم خامدون قد اخمدت اصواتهم وسكنت حركاتهم ولم يبق منهم عين تطرف ولا نندس تتردد وهده نهاي كل من كدب بيات الله 9راسله واعترض عل امرالله تعال ونستفيد من هذه النبح اشيا مهم منها التصديق بكل ماجا الرسل الكرام والايمان بالله واليوم الخر الدعوال الله تعال واجب عل كل مسلم تجاه اهله وكل من هم تحت امرته ورعايته جزا من يمن بالله  ورسله دخول الجن والتنعم بها ندعو الله ان يجهلنا ممن يتعظون بالقصص القرني وهونعم المول ونعم النصبر']\n",
            "capr10.png\n",
            "['كتبت بدري الاسماعيلي بالتعاون بين مدرس جمير بنت ثابت وعماد شون الطلاب بجامع السلطان قابوس ممثل بجماع الفنون التشكيلب تم افتتاح المعرض الفب عبر بوالب الزمن وذلك تحت رعاي سعاد المكرم لميس بنت عبدالله الطاي عصو مجلس الدول وذلك بمركر حدمات الطلاب حيت ذرم المعرض مجموع من اللوحات الفنب والمعماري والمستوحا من البي العماني وتم في اللوحات توظيف فن الكولاج والذي يعني 9ن التجميع والالصاق ويعتبر فن الكولاج من وساط التعابير الفنب الحديث فوامه توطيف خامات فنب متنوع كقصاصات الاوراق والاقمش والكرتون والمواد المستهلك تضاف اليها بعض الخطوط والابواب لاحداث تثيرات فن! ثلاثي الابعاد تصفي فضا اللوح وجا المعرض اختتاما للحلق التي اشرف عليها الدكتور تيسير طبيشات اخصاي الفنون التشكيلي والتب استمرت ع مد اسبوع وقد شارك في الحلق عدد من مدرب التربي الفنب  التابع لمديري السبب']\n",
            "capr2.png\n",
            "['فى المحطًسة', 'صعدت آلقطار  تًوجًهت إلى أوًل مقعد وًوًضعت حقيبتي غلى آلرًفق ووقفت أمام آلنًافذة أنظر إلى آلناس المسافرون   مسرعون يتوجًهون نحو آلعر بات  وهم يحملون أمتعتهم  بينمًا ترئفع أصوات باعة آلصحف وآلمشروبات دوًت آلصًفًارة وبدأ ألقطار يتحرًك وبقيت واقفاً قرب آلنًافذة  أراقبح حركةً آلناس ( وألأيدي آلتي تودع .']\n",
            "cdd.jpg\n",
            "['أدب المرء خير من ذهبه', '6م6 ى 4` ،[ ع4 $1 ى1  4']\n",
            "cddd.jpg\n",
            "['موقع الفونت']\n",
            "font_preview-ae8a8c44055469537eec30890fd91d074584.png\n",
            "['العربية', '480440053 ٨ سا ']\n",
            "hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg\n",
            "['بعد زبع قرن من الغياب الشحوق لرؤية الاهل توفيت الراكبحة جورجي ت بشير ٦٩١ عاما وهسي كندية مسن اصل مصري داخل صالة يرانزيت مطار القاهرة بعداول زيارة لها الى مصر متئثرة بإصابتها بهبوط حساد فسي الدورة الدمويحة قبل دقائ ق من صعودها الى الطائرة المصريحة المتجهة الى الولايات المتحسدة الامير كية .']\n",
            "kashida-justification.png\n",
            "['رمضان كرنم']\n",
            "pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg\n",
            "['كن على ثقة أنك شخص عظيم أوجده الله لهدف وغاية ووضع فيك ما يميزك عن غيرك . قد تتعثرفي طريقك و قد تفقد توازنك وتحزن وتنطفئ روحك لكنك لست بعاجز أو أقل من غيرك لاتلتفت لكل ما يحبطك . أنت وحدا من يستطيع أن يفجر طاقاتك أنت من تصنع سعادتك وتغير حياتك  للأفضل تأمل نفسك فقط']\n",
            "r.jpg\n",
            "['تحية لكل بنت لون عيونهآ نىة']\n",
            "sti.jpg\n",
            "['أحب نفسك أولا']\n",
            "traditional-arabic-regular.png\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "# Create new columns for reference, CER and WER\n",
        "df_output['ref_text'] = ''\n",
        "df_output['cer'] = ''\n",
        "df_output['wer'] = ''\n",
        "\n",
        "# Replace new lines in output\n",
        "df_output['ocr_output'] = df_output['ocr_output'].apply(lambda x: x.replace(']','').replace('[','').replace(\"'\",''))\n",
        "\n",
        "\n",
        "df_output.loc[df_output['img_filename'] == '800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png', 'ref_text'] = \"خط لمحة النحيف خط لمحة العادي خط لمحة العريض\"\n",
        "df_output.loc[df_output['img_filename'] == 'Arabic_Typesetting_Font.svg.png', 'ref_text'] = \"خط الطباعة العربي\"\n",
        "df_output.loc[df_output['img_filename'] == 'font_preview-ae8a8c44055469537eec30890fd91d074584.png', 'ref_text'] = \"موقع الفونت\"\n",
        "df_output.loc[df_output['img_filename'] == 'traditional-arabic-regular.png', 'ref_text'] = \"أحب نفسك أولا\"\n",
        "df_output.loc[df_output['img_filename'] == 'r.jpg', 'ref_text'] = \"كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية، ووضع فيك ما يميزك، عن غيرك, قد تتعثر في طريقك و قد تفقد توازنك و تحزن وتنطفئ روحك، لكنك لست بعاجز أو أقل من غيرك، لا تلتفت لكل ما يحبطك، أنت وحدك من يستطيع أن يفجّر طاقاتك، أنت من تصنع سعادتك وتغير حياتك للأفضل , تأمل نفسك فقط\"\n",
        "df_output.loc[df_output['img_filename'] == 'arabic-words-and-phrases-vector-22578359.jpg', 'ref_text'] = \"مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما هذا ماذا تعمل سلام ماذا تحتاج الكحول\"\n",
        "df_output.loc[df_output['img_filename'] == 'pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg', 'ref_text'] = \"رمضان كريم\"\n",
        "df_output.loc[df_output['img_filename'] == 'kashida-justification.png', 'ref_text'] = \"بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت الراكبة جورجيت بشير (٦٩ عاما) وهي كندية من اصل مصري، داخل صالة يرانزيت مطار القاهرة بعد اول زيارة لها الى مصر متئثرة بإصابتها بهبوط حاد في الدورة الدموية قبل دقائق من صعودها الى الطائرة المصرية المتجهة الى الولايات المتحدة الاميركية\"\n",
        "df_output.loc[df_output['img_filename'] == 'cddd.jpg', 'ref_text'] = \"أدبُ المرءِ خيرٌ من ذهبهِ\"\n",
        "df_output.loc[df_output['img_filename'] == 'cdd.jpg', 'ref_text'] = \"صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْعَد، وَوَضَعْتُ حَقِيبَتِي عَلَى الرَّفّ، وَوَقَفْتُ أمام النَّافِدَةِ أَنْظُرُ إِلَى النَّاس المُسَافِرُون مُسْرِعُون، يَتَوَجَّهُون نَحْوَ العَرَبَات، وَ هُمْ يَحْمِلُون أَمِْتعَتَهُم، بَيْنَمَا تَرْتَفِع أَصْوَاتُ بَاعَةِ الصُّحُفِ وَ المَشْرُوبَات دَوَّتِ الصَّفَّارَةُ، وَ بَدَأَ القِطَارُيَتَحَرّكَ، وَ بَقِيتُ واقِفًا قُرْبَ النَّافِذَة، أُرَاقِبُ حَرَكَةَ النَّاس، وَ الأَيْدِي اّلتِي تُوَدِّع\"\n",
        "df_output.loc[df_output['img_filename'] == 'sti.jpg', 'ref_text'] = \"تحيّة لكل بنت لون عيونهآ بنية\"\n",
        "df_output.loc[df_output['img_filename'] == 'capr2.png', 'ref_text'] = \"كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بنت ثابت وعماد شون الطلاب بجامع السلطان قابوس ممثل بجماع الفنون التشكيلي تم افتتاح المعرض الغني عبر بواب الزمن وذلك تحت رعاي سعاد المكرم لميس بنت عبدالله الطاي عضو مجلس الدول وذلك بمركز خدمات الطلاب حيث ضم المعرض مجموع من اللوحات الفني والمعماري والمستوحا من البي العماني وتم في اللوحات توظيف فن الكولاج والذي يعني فن التجميع والالصاق ويعتبر فن الكولاج من وساط التعابير الفني الحديث قوامه توظيف خامات فني متنوع كقصاصات الاوراق والاقمش والكرتون والمواد المستهلك تضاف اليها بعض الخطوط والابواب لاحداث تثيرات فني ثلاثي الابعاد تضفي فضا اللوح وجا المعرض اختتاما للحلق التي اشرف عليها الدكتور تيسير طبيشات اخصاي الفنون التشكيلي والتي استمرت عل مد اسبوع وقد شارك في الحلق عدد من مدرسي التربي الفني التابع لمديري السيب\"\n",
        "df_output.loc[df_output['img_filename'] == 'capr10.png', 'ref_text'] = \"يقول الله تبارك وتعال واضرب لهم مثلا اصحاب القري اذ جاها المرسلون اذا ارسلنا اليهم اثنين فكذبوهما فعززنا بثالث فقالوا انا اليكم مرسلون اولا ما هي قصتهم لم يذكر لنا القرن الكريم من هم اصحاب القري ولا ماهي القري وهناك روايات كثير ولا طال من ورا الجر معها انما ما يهمنا من هذه القص هي العبر والعظ منها فهي قري ارسل الله اليها رسولين فكذبوهما اهل تلك القري فعززهما الله برسول ثالث وتقدموا ثلائتهم بدعواهم ودعوتهم من جديد فقالوا انا اليكم مرسلون وهنا اعترض اهل القري بالاعتراضات المكرر في تاريخ الرسل والرسالات قالوا ما انتم الا بشر مثلنا وما انزل الرحمن من شي ان انتم الا تكذبون وفي ثق الممن المطمن ال الصدق العارف بحدود وظيفته اجابهم الرسل قالوا ربنا يعلم انا اليكم لمرسلون وما علينا الا البلاغ المبين اي ان الله يعلم هذا ويكفي وان وظيف الرسل هي البلاغ وقد ادوه والناس بعد ذلك احرار فيما يتخذونه لانفسهم من تصرف وفيما يحملون في تصرفهم من اوزار والامر بين الرسل وبين الناس هو امر ذلك التبليغ عن الله تعال فمت تحقق ذلك فالمر كله بعد ذلك لله ولكن المكذبين كعادتهم لا يخذون الامور عل هذا المخذ الواضح ولا يطيقون وجود الدعا ال الهد فتخذهم العز بالاثم ويعمدون ال الاسلوب الغليظ في مقاوم الحج لان الباطل ضيق الصدر قالوا انا تطيرنا بكم لن لم تنتهوا لنرجمنكم وليمسنكم منا عذاب اليم وهكذا اسفر الباطل عن غشمه واطلق عل الهدا تهديده ولكن الواجب عل الرسل ان يسيروا في طريق دعوتهم لدا الواجب عليهم فردوا عليهم قالوا طاركم معكم لان القول بالتشام خراف وواجب الرسل ان يبينوا لقومهم انها خراف وان حظهم ونصيبهم من خير ومن شر لا يتيهم من خارج انقسهم انما هو معهم مرتبط بنواياهم واعمالهم متوقف عل كسبهم وعملهم وفي وسعهم ان يجعلوا حظهم ونصيبهم خيرا او ان يجعلوه شرا ان ذكرتم يعن اتعذبون وترجمونا لاننا نذكركم افهذا جزاا التذكير بل انتم قوم مسرفون يعن تجاوزتم الحدود وتردون عل الدعو ال الخيرتردون بالرجم والتعذيب ولكن داما تجد الخير في قلوب بعض الرجال وتجد الفطر السليم في الداعي المازر والمناصر لدين الحق فهذا رجل يسمع لدعو الحق فينطق بكلم الحق المبين قال تعالوجا من قص المدين رجل يسع قال يا قوم اتبعوا المرسلين اتبعوا من لا يسلكم اجرا وهم مهتدون اي ان الذي يدعو مثل هذه الدعو وهو لا يطلب اجرا انه لصادق والا فما الذي يحمله عل هذا العنا ان لم يكن يلب تكليفا من الله تعال ودعوتهم واضح فهم يدعون ال اله واحد ويدعون ال منهج سليم ثم عاد هذا الرجل الممن يتحدث اليهم عن نفسه وعن اسباب ايمانه ومالي لا اعبد الذي فطرني واليه ترجعون يتسال لم لا اعبد الذي فطرني وهو اليه المرجع والمصير ثم اخذ يبين لهم ان من يخالف هذا المنهج فنهايته معروف ثم يلق كلم النهاي اني منت بربكم فاسمعون هكذا الق كلم الايمان الوائق واشهدهم عليها ويوحي سياق القص ان قومه لم يمهلوه وقتلوه وتنتهي الدنيا ونراه في العالم الخر وقد اكرمه الله بدخول الجن قيل ادخل الجن قال يا ليت قومي يعلمون بما غفر لي ربي وجعلني من المكرمين ونر الرجل الممن بعد ان اراه الله منزلته في الجن يقول ويتمن لو يراه قومه وقد اتاه الله من الكرام والمغفر ليعرفوا الحق معرف اليقين ويخبرنا الله تعال انه انتقم من قومه بعد قتلهم اياه غضبا منه تبارك وتعال عليهم لانهم كذبوا رسله وقتلوا وليه ويذكر الله تعال ما انزل عليهم من عذاب قال تعالان كانت الا صيح واحد فذا هم خامدون قال علما التفسير بعث الله اليهم جبريل عليه السلام فخذ بعضادتي الباب الذي ببلدهم ثم صاح بهم صيح واحد فذا هم خامدون قد اخمدت اصواتهم وسكنت حركانهم ولم يبق منهم عين تطرف ولا نفس تتردد وهذه نهاي كل من كذب بيات الله ورسله واعترض عل امر الله تعال ونستفيد من هذه القص اشيا مهم منها التصديق بكل ما جا الرسل الكرام والايمان بالله واليوم الخر الدعو ال الله تعال واجب عل كل مسلم تجاه اهله وكل من هم تحت امرته ورعايته جزا من يمن بالله ورسله دخول الجن والتنعم بها ندعو الله ان يجعلنا ممن يتعظون بالقصص القرني وهو نعم المول ونعم النصير\"\n",
        "\n",
        "df_output.loc[df_output['img_filename'] == 'hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg', 'ref_text'] = \"العربية\"\n",
        "\n",
        "\n",
        "\n",
        "\n"
      ],
      "metadata": {
        "id": "fxOM-VNtS0hj"
      },
      "execution_count": null,
      "outputs": []
    },
    {
      "cell_type": "code",
      "source": [
        "df_output"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/",
          "height": 488
        },
        "id": "WNYCNLWoS0lP",
        "outputId": "2b8c32ce-b451-4500-f180-e65bb0e1425b"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "                                         img_filename  \\\n",
              "0   800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...   \n",
              "1                     Arabic_Typesetting_Font.svg.png   \n",
              "2        arabic-words-and-phrases-vector-22578359.jpg   \n",
              "3                                          capr10.png   \n",
              "4                                           capr2.png   \n",
              "5                                             cdd.jpg   \n",
              "6                                            cddd.jpg   \n",
              "7   font_preview-ae8a8c44055469537eec30890fd91d074...   \n",
              "8   hand-writing-on-blackboard-language-260nw-4804...   \n",
              "9                           kashida-justification.png   \n",
              "10  pngtree-ramadan-kareem-greetings-arabic-text-t...   \n",
              "11                                              r.jpg   \n",
              "12                                            sti.jpg   \n",
              "13                     traditional-arabic-regular.png   \n",
              "\n",
              "                                           ocr_output  \\\n",
              "0        خ طلمحة النحيف خط لمحة العادي خط لمحة العريض   \n",
              "1                                                       \n",
              "2   مايسان ماذا تريد ماذا حصل أديسون ماذا قللم ما ...   \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...   \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جمير بن...   \n",
              "5   فى المحطًسة, صعدت آلقطار  تًوجًهت إلى أوًل مقع...   \n",
              "6       أدب المرء خير من ذهبه, 6م6 ى 4` ، ع4 $1 ى1  4   \n",
              "7                                         موقع الفونت   \n",
              "8                            العربية, 480440053 ٨ سا    \n",
              "9   بعد زبع قرن من الغياب الشحوق لرؤية الاهل توفيت...   \n",
              "10                                         رمضان كرنم   \n",
              "11  كن على ثقة أنك شخص عظيم أوجده الله لهدف وغاية ...   \n",
              "12                        تحية لكل بنت لون عيونهآ نىة   \n",
              "13                                      أحب نفسك أولا   \n",
              "\n",
              "                                             ref_text cer wer  \n",
              "0        خط لمحة النحيف خط لمحة العادي خط لمحة العريض          \n",
              "1                                   خط الطباعة العربي          \n",
              "2   مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...          \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...          \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...          \n",
              "5   صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...          \n",
              "6                           أدبُ المرءِ خيرٌ من ذهبهِ          \n",
              "7                                         موقع الفونت          \n",
              "8                                             العربية          \n",
              "9   بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...          \n",
              "10                                         رمضان كريم          \n",
              "11  كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...          \n",
              "12                      تحيّة لكل بنت لون عيونهآ بنية          \n",
              "13                                      أحب نفسك أولا          "
            ],
            "text/html": [
              "\n",
              "  <div id=\"df-f60d66e2-66c1-493e-a13d-f4038a9982e0\">\n",
              "    <div class=\"colab-df-container\">\n",
              "      <div>\n",
              "<style scoped>\n",
              "    .dataframe tbody tr th:only-of-type {\n",
              "        vertical-align: middle;\n",
              "    }\n",
              "\n",
              "    .dataframe tbody tr th {\n",
              "        vertical-align: top;\n",
              "    }\n",
              "\n",
              "    .dataframe thead th {\n",
              "        text-align: right;\n",
              "    }\n",
              "</style>\n",
              "<table border=\"1\" class=\"dataframe\">\n",
              "  <thead>\n",
              "    <tr style=\"text-align: right;\">\n",
              "      <th></th>\n",
              "      <th>img_filename</th>\n",
              "      <th>ocr_output</th>\n",
              "      <th>ref_text</th>\n",
              "      <th>cer</th>\n",
              "      <th>wer</th>\n",
              "    </tr>\n",
              "  </thead>\n",
              "  <tbody>\n",
              "    <tr>\n",
              "      <th>0</th>\n",
              "      <td>800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...</td>\n",
              "      <td>خ طلمحة النحيف خط لمحة العادي خط لمحة العريض</td>\n",
              "      <td>خط لمحة النحيف خط لمحة العادي خط لمحة العريض</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>1</th>\n",
              "      <td>Arabic_Typesetting_Font.svg.png</td>\n",
              "      <td></td>\n",
              "      <td>خط الطباعة العربي</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>2</th>\n",
              "      <td>arabic-words-and-phrases-vector-22578359.jpg</td>\n",
              "      <td>مايسان ماذا تريد ماذا حصل أديسون ماذا قللم ما ...</td>\n",
              "      <td>مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>3</th>\n",
              "      <td>capr10.png</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>4</th>\n",
              "      <td>capr2.png</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جمير بن...</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>5</th>\n",
              "      <td>cdd.jpg</td>\n",
              "      <td>فى المحطًسة, صعدت آلقطار  تًوجًهت إلى أوًل مقع...</td>\n",
              "      <td>صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>6</th>\n",
              "      <td>cddd.jpg</td>\n",
              "      <td>أدب المرء خير من ذهبه, 6م6 ى 4` ، ع4 $1 ى1  4</td>\n",
              "      <td>أدبُ المرءِ خيرٌ من ذهبهِ</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>7</th>\n",
              "      <td>font_preview-ae8a8c44055469537eec30890fd91d074...</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>8</th>\n",
              "      <td>hand-writing-on-blackboard-language-260nw-4804...</td>\n",
              "      <td>العربية, 480440053 ٨ سا</td>\n",
              "      <td>العربية</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>9</th>\n",
              "      <td>kashida-justification.png</td>\n",
              "      <td>بعد زبع قرن من الغياب الشحوق لرؤية الاهل توفيت...</td>\n",
              "      <td>بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>10</th>\n",
              "      <td>pngtree-ramadan-kareem-greetings-arabic-text-t...</td>\n",
              "      <td>رمضان كرنم</td>\n",
              "      <td>رمضان كريم</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>11</th>\n",
              "      <td>r.jpg</td>\n",
              "      <td>كن على ثقة أنك شخص عظيم أوجده الله لهدف وغاية ...</td>\n",
              "      <td>كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>12</th>\n",
              "      <td>sti.jpg</td>\n",
              "      <td>تحية لكل بنت لون عيونهآ نىة</td>\n",
              "      <td>تحيّة لكل بنت لون عيونهآ بنية</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>13</th>\n",
              "      <td>traditional-arabic-regular.png</td>\n",
              "      <td>أحب نفسك أولا</td>\n",
              "      <td>أحب نفسك أولا</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "  </tbody>\n",
              "</table>\n",
              "</div>\n",
              "      <button class=\"colab-df-convert\" onclick=\"convertToInteractive('df-f60d66e2-66c1-493e-a13d-f4038a9982e0')\"\n",
              "              title=\"Convert this dataframe to an interactive table.\"\n",
              "              style=\"display:none;\">\n",
              "        \n",
              "  <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24px\"viewBox=\"0 0 24 24\"\n",
              "       width=\"24px\">\n",
              "    <path d=\"M0 0h24v24H0V0z\" fill=\"none\"/>\n",
              "    <path d=\"M18.56 5.44l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94zm-11 1L8.5 8.5l.94-2.06 2.06-.94-2.06-.94L8.5 2.5l-.94 2.06-2.06.94zm10 10l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94z\"/><path d=\"M17.41 7.96l-1.37-1.37c-.4-.4-.92-.59-1.43-.59-.52 0-1.04.2-1.43.59L10.3 9.45l-7.72 7.72c-.78.78-.78 2.05 0 2.83L4 21.41c.39.39.9.59 1.41.59.51 0 1.02-.2 1.41-.59l7.78-7.78 2.81-2.81c.8-.78.8-2.07 0-2.86zM5.41 20L4 18.59l7.72-7.72 1.47 1.35L5.41 20z\"/>\n",
              "  </svg>\n",
              "      </button>\n",
              "      \n",
              "  <style>\n",
              "    .colab-df-container {\n",
              "      display:flex;\n",
              "      flex-wrap:wrap;\n",
              "      gap: 12px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert {\n",
              "      background-color: #E8F0FE;\n",
              "      border: none;\n",
              "      border-radius: 50%;\n",
              "      cursor: pointer;\n",
              "      display: none;\n",
              "      fill: #1967D2;\n",
              "      height: 32px;\n",
              "      padding: 0 0 0 0;\n",
              "      width: 32px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert:hover {\n",
              "      background-color: #E2EBFA;\n",
              "      box-shadow: 0px 1px 2px rgba(60, 64, 67, 0.3), 0px 1px 3px 1px rgba(60, 64, 67, 0.15);\n",
              "      fill: #174EA6;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert {\n",
              "      background-color: #3B4455;\n",
              "      fill: #D2E3FC;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert:hover {\n",
              "      background-color: #434B5C;\n",
              "      box-shadow: 0px 1px 3px 1px rgba(0, 0, 0, 0.15);\n",
              "      filter: drop-shadow(0px 1px 2px rgba(0, 0, 0, 0.3));\n",
              "      fill: #FFFFFF;\n",
              "    }\n",
              "  </style>\n",
              "\n",
              "      <script>\n",
              "        const buttonEl =\n",
              "          document.querySelector('#df-f60d66e2-66c1-493e-a13d-f4038a9982e0 button.colab-df-convert');\n",
              "        buttonEl.style.display =\n",
              "          google.colab.kernel.accessAllowed ? 'block' : 'none';\n",
              "\n",
              "        async function convertToInteractive(key) {\n",
              "          const element = document.querySelector('#df-f60d66e2-66c1-493e-a13d-f4038a9982e0');\n",
              "          const dataTable =\n",
              "            await google.colab.kernel.invokeFunction('convertToInteractive',\n",
              "                                                     [key], {});\n",
              "          if (!dataTable) return;\n",
              "\n",
              "          const docLinkHtml = 'Like what you see? Visit the ' +\n",
              "            '<a target=\"_blank\" href=https://colab.research.google.com/notebooks/data_table.ipynb>data table notebook</a>'\n",
              "            + ' to learn more about interactive tables.';\n",
              "          element.innerHTML = '';\n",
              "          dataTable['output_type'] = 'display_data';\n",
              "          await google.colab.output.renderOutput(dataTable, element);\n",
              "          const docLink = document.createElement('div');\n",
              "          docLink.innerHTML = docLinkHtml;\n",
              "          element.appendChild(docLink);\n",
              "        }\n",
              "      </script>\n",
              "    </div>\n",
              "  </div>\n",
              "  "
            ]
          },
          "metadata": {},
          "execution_count": 103
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "for index, row in df_output.iterrows():\n",
        "  filename = row['img_filename']\n",
        "  ref = row['ref_text']\n",
        "  output = row['ocr_output']\n",
        "  cer = fastwer.score_sent(output, ref, char_level=True)\n",
        "  wer = fastwer.score_sent(output, ref, char_level=False)\n",
        "  df_output.loc[df_output['img_filename'] == filename, 'cer'] = round(cer,2) # Round value to 2 decimal places\n",
        "  df_output.loc[df_output['img_filename'] == filename, 'wer'] = round(wer,2)\n",
        "\n",
        "df_output"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/",
          "height": 488
        },
        "id": "7DH8cTQtWg25",
        "outputId": "0e4f552b-48cc-490f-8643-e80ef3f76ed8"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "                                         img_filename  \\\n",
              "0   800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...   \n",
              "1                     Arabic_Typesetting_Font.svg.png   \n",
              "2        arabic-words-and-phrases-vector-22578359.jpg   \n",
              "3                                          capr10.png   \n",
              "4                                           capr2.png   \n",
              "5                                             cdd.jpg   \n",
              "6                                            cddd.jpg   \n",
              "7   font_preview-ae8a8c44055469537eec30890fd91d074...   \n",
              "8   hand-writing-on-blackboard-language-260nw-4804...   \n",
              "9                           kashida-justification.png   \n",
              "10  pngtree-ramadan-kareem-greetings-arabic-text-t...   \n",
              "11                                              r.jpg   \n",
              "12                                            sti.jpg   \n",
              "13                     traditional-arabic-regular.png   \n",
              "\n",
              "                                           ocr_output  \\\n",
              "0        خ طلمحة النحيف خط لمحة العادي خط لمحة العريض   \n",
              "1                                                       \n",
              "2   مايسان ماذا تريد ماذا حصل أديسون ماذا قللم ما ...   \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...   \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جمير بن...   \n",
              "5   فى المحطًسة, صعدت آلقطار  تًوجًهت إلى أوًل مقع...   \n",
              "6       أدب المرء خير من ذهبه, 6م6 ى 4` ، ع4 $1 ى1  4   \n",
              "7                                         موقع الفونت   \n",
              "8                            العربية, 480440053 ٨ سا    \n",
              "9   بعد زبع قرن من الغياب الشحوق لرؤية الاهل توفيت...   \n",
              "10                                         رمضان كرنم   \n",
              "11  كن على ثقة أنك شخص عظيم أوجده الله لهدف وغاية ...   \n",
              "12                        تحية لكل بنت لون عيونهآ نىة   \n",
              "13                                      أحب نفسك أولا   \n",
              "\n",
              "                                             ref_text     cer    wer  \n",
              "0        خط لمحة النحيف خط لمحة العادي خط لمحة العريض     2.5  22.22  \n",
              "1                                   خط الطباعة العربي   100.0  100.0  \n",
              "2   مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...    25.5  31.25  \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...    3.92  17.36  \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...    3.11  18.11  \n",
              "5   صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...   43.74  110.2  \n",
              "6                           أدبُ المرءِ خيرٌ من ذهبهِ   73.91  260.0  \n",
              "7                                         موقع الفونت     0.0    0.0  \n",
              "8                                             العربية  142.86  400.0  \n",
              "9   بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...     6.3  42.86  \n",
              "10                                         رمضان كريم    5.26   50.0  \n",
              "11  كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...    5.32  34.48  \n",
              "12                      تحيّة لكل بنت لون عيونهآ بنية    9.43  33.33  \n",
              "13                                      أحب نفسك أولا     0.0    0.0  "
            ],
            "text/html": [
              "\n",
              "  <div id=\"df-f375f8c4-3136-4355-a2ee-2346d64c77a6\">\n",
              "    <div class=\"colab-df-container\">\n",
              "      <div>\n",
              "<style scoped>\n",
              "    .dataframe tbody tr th:only-of-type {\n",
              "        vertical-align: middle;\n",
              "    }\n",
              "\n",
              "    .dataframe tbody tr th {\n",
              "        vertical-align: top;\n",
              "    }\n",
              "\n",
              "    .dataframe thead th {\n",
              "        text-align: right;\n",
              "    }\n",
              "</style>\n",
              "<table border=\"1\" class=\"dataframe\">\n",
              "  <thead>\n",
              "    <tr style=\"text-align: right;\">\n",
              "      <th></th>\n",
              "      <th>img_filename</th>\n",
              "      <th>ocr_output</th>\n",
              "      <th>ref_text</th>\n",
              "      <th>cer</th>\n",
              "      <th>wer</th>\n",
              "    </tr>\n",
              "  </thead>\n",
              "  <tbody>\n",
              "    <tr>\n",
              "      <th>0</th>\n",
              "      <td>800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...</td>\n",
              "      <td>خ طلمحة النحيف خط لمحة العادي خط لمحة العريض</td>\n",
              "      <td>خط لمحة النحيف خط لمحة العادي خط لمحة العريض</td>\n",
              "      <td>2.5</td>\n",
              "      <td>22.22</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>1</th>\n",
              "      <td>Arabic_Typesetting_Font.svg.png</td>\n",
              "      <td></td>\n",
              "      <td>خط الطباعة العربي</td>\n",
              "      <td>100.0</td>\n",
              "      <td>100.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>2</th>\n",
              "      <td>arabic-words-and-phrases-vector-22578359.jpg</td>\n",
              "      <td>مايسان ماذا تريد ماذا حصل أديسون ماذا قللم ما ...</td>\n",
              "      <td>مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...</td>\n",
              "      <td>25.5</td>\n",
              "      <td>31.25</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>3</th>\n",
              "      <td>capr10.png</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td>3.92</td>\n",
              "      <td>17.36</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>4</th>\n",
              "      <td>capr2.png</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جمير بن...</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...</td>\n",
              "      <td>3.11</td>\n",
              "      <td>18.11</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>5</th>\n",
              "      <td>cdd.jpg</td>\n",
              "      <td>فى المحطًسة, صعدت آلقطار  تًوجًهت إلى أوًل مقع...</td>\n",
              "      <td>صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...</td>\n",
              "      <td>43.74</td>\n",
              "      <td>110.2</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>6</th>\n",
              "      <td>cddd.jpg</td>\n",
              "      <td>أدب المرء خير من ذهبه, 6م6 ى 4` ، ع4 $1 ى1  4</td>\n",
              "      <td>أدبُ المرءِ خيرٌ من ذهبهِ</td>\n",
              "      <td>73.91</td>\n",
              "      <td>260.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>7</th>\n",
              "      <td>font_preview-ae8a8c44055469537eec30890fd91d074...</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td>0.0</td>\n",
              "      <td>0.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>8</th>\n",
              "      <td>hand-writing-on-blackboard-language-260nw-4804...</td>\n",
              "      <td>العربية, 480440053 ٨ سا</td>\n",
              "      <td>العربية</td>\n",
              "      <td>142.86</td>\n",
              "      <td>400.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>9</th>\n",
              "      <td>kashida-justification.png</td>\n",
              "      <td>بعد زبع قرن من الغياب الشحوق لرؤية الاهل توفيت...</td>\n",
              "      <td>بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...</td>\n",
              "      <td>6.3</td>\n",
              "      <td>42.86</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>10</th>\n",
              "      <td>pngtree-ramadan-kareem-greetings-arabic-text-t...</td>\n",
              "      <td>رمضان كرنم</td>\n",
              "      <td>رمضان كريم</td>\n",
              "      <td>5.26</td>\n",
              "      <td>50.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>11</th>\n",
              "      <td>r.jpg</td>\n",
              "      <td>كن على ثقة أنك شخص عظيم أوجده الله لهدف وغاية ...</td>\n",
              "      <td>كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...</td>\n",
              "      <td>5.32</td>\n",
              "      <td>34.48</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>12</th>\n",
              "      <td>sti.jpg</td>\n",
              "      <td>تحية لكل بنت لون عيونهآ نىة</td>\n",
              "      <td>تحيّة لكل بنت لون عيونهآ بنية</td>\n",
              "      <td>9.43</td>\n",
              "      <td>33.33</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>13</th>\n",
              "      <td>traditional-arabic-regular.png</td>\n",
              "      <td>أحب نفسك أولا</td>\n",
              "      <td>أحب نفسك أولا</td>\n",
              "      <td>0.0</td>\n",
              "      <td>0.0</td>\n",
              "    </tr>\n",
              "  </tbody>\n",
              "</table>\n",
              "</div>\n",
              "      <button class=\"colab-df-convert\" onclick=\"convertToInteractive('df-f375f8c4-3136-4355-a2ee-2346d64c77a6')\"\n",
              "              title=\"Convert this dataframe to an interactive table.\"\n",
              "              style=\"display:none;\">\n",
              "        \n",
              "  <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24px\"viewBox=\"0 0 24 24\"\n",
              "       width=\"24px\">\n",
              "    <path d=\"M0 0h24v24H0V0z\" fill=\"none\"/>\n",
              "    <path d=\"M18.56 5.44l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94zm-11 1L8.5 8.5l.94-2.06 2.06-.94-2.06-.94L8.5 2.5l-.94 2.06-2.06.94zm10 10l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94z\"/><path d=\"M17.41 7.96l-1.37-1.37c-.4-.4-.92-.59-1.43-.59-.52 0-1.04.2-1.43.59L10.3 9.45l-7.72 7.72c-.78.78-.78 2.05 0 2.83L4 21.41c.39.39.9.59 1.41.59.51 0 1.02-.2 1.41-.59l7.78-7.78 2.81-2.81c.8-.78.8-2.07 0-2.86zM5.41 20L4 18.59l7.72-7.72 1.47 1.35L5.41 20z\"/>\n",
              "  </svg>\n",
              "      </button>\n",
              "      \n",
              "  <style>\n",
              "    .colab-df-container {\n",
              "      display:flex;\n",
              "      flex-wrap:wrap;\n",
              "      gap: 12px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert {\n",
              "      background-color: #E8F0FE;\n",
              "      border: none;\n",
              "      border-radius: 50%;\n",
              "      cursor: pointer;\n",
              "      display: none;\n",
              "      fill: #1967D2;\n",
              "      height: 32px;\n",
              "      padding: 0 0 0 0;\n",
              "      width: 32px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert:hover {\n",
              "      background-color: #E2EBFA;\n",
              "      box-shadow: 0px 1px 2px rgba(60, 64, 67, 0.3), 0px 1px 3px 1px rgba(60, 64, 67, 0.15);\n",
              "      fill: #174EA6;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert {\n",
              "      background-color: #3B4455;\n",
              "      fill: #D2E3FC;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert:hover {\n",
              "      background-color: #434B5C;\n",
              "      box-shadow: 0px 1px 3px 1px rgba(0, 0, 0, 0.15);\n",
              "      filter: drop-shadow(0px 1px 2px rgba(0, 0, 0, 0.3));\n",
              "      fill: #FFFFFF;\n",
              "    }\n",
              "  </style>\n",
              "\n",
              "      <script>\n",
              "        const buttonEl =\n",
              "          document.querySelector('#df-f375f8c4-3136-4355-a2ee-2346d64c77a6 button.colab-df-convert');\n",
              "        buttonEl.style.display =\n",
              "          google.colab.kernel.accessAllowed ? 'block' : 'none';\n",
              "\n",
              "        async function convertToInteractive(key) {\n",
              "          const element = document.querySelector('#df-f375f8c4-3136-4355-a2ee-2346d64c77a6');\n",
              "          const dataTable =\n",
              "            await google.colab.kernel.invokeFunction('convertToInteractive',\n",
              "                                                     [key], {});\n",
              "          if (!dataTable) return;\n",
              "\n",
              "          const docLinkHtml = 'Like what you see? Visit the ' +\n",
              "            '<a target=\"_blank\" href=https://colab.research.google.com/notebooks/data_table.ipynb>data table notebook</a>'\n",
              "            + ' to learn more about interactive tables.';\n",
              "          element.innerHTML = '';\n",
              "          dataTable['output_type'] = 'display_data';\n",
              "          await google.colab.output.renderOutput(dataTable, element);\n",
              "          const docLink = document.createElement('div');\n",
              "          docLink.innerHTML = docLinkHtml;\n",
              "          element.appendChild(docLink);\n",
              "        }\n",
              "      </script>\n",
              "    </div>\n",
              "  </div>\n",
              "  "
            ]
          },
          "metadata": {},
          "execution_count": 104
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "# Overall performances\n",
        "mean_cer = df_output['cer'].mean()\n",
        "mean_wer = df_output['wer'].mean()\n",
        "print(f'Mean CER = {mean_cer}%, Mean WER = {mean_wer}%')"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "-Wm5i9G5Wg6T",
        "outputId": "0be66913-183b-4f6d-db34-8453116313c2"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Mean CER = 30.13214285714286%, Mean WER = 79.98642857142856%\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "from google.colab import drive\n",
        "\n",
        "drive.mount('/content/drive')"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "XNWWG114SAR8",
        "outputId": "c7618ac7-b86d-4902-aaeb-8a7a47bcb847"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Drive already mounted at /content/drive; to attempt to forcibly remount, call drive.mount(\"/content/drive\", force_remount=True).\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        ""
      ],
      "metadata": {
        "id": "Yftsbtc6qkXv"
      },
      "execution_count": null,
      "outputs": []
    }
  ]
}